#include <gnome.h>
#include <gst/gst.h>

extern gboolean _gst_plugin_spew;

gboolean idle_func(gpointer data);

GtkWidget *drawingarea;

int main(int argc,char *argv[]) {
  GstElement *bin;
  GstElementFactory *srcfactory;
  GstElement *src;
  GstElementFactory *mp3factory;
  GstElement *mp3;
  GstElementFactory *wavefactory;
  GstElement *wave;

  GtkWidget *appwindow;

  _gst_plugin_spew = TRUE;

  gst_init(&argc,&argv);
  gst_plugin_load("libsmoothwave.so");
  gst_plugin_load("libgstxa.so");
  gnome_init("MP3Wave","0.0.1",argc,argv);

  bin = gst_bin_new("bin");

  srcfactory = gst_elementfactory_find("fdsrc");
  printf("srcfactory is %p\n",srcfactory);
  mp3factory = gst_elementfactory_find("xa");
  printf("mp3factory is %p\n",mp3factory);
  wavefactory = gst_elementfactory_find("smoothwave");
  printf("wavefactory is %p\n",wavefactory);

  src = gst_elementfactory_create(srcfactory,"src");
  gtk_object_set(GTK_OBJECT(src),"bytes_per_read",(gulong)1024,NULL);
  mp3 = gst_elementfactory_create(mp3factory,"mp3");
  wave = gst_elementfactory_create(wavefactory,"wave");
  gtk_object_set(GTK_OBJECT(wave),"width",256,"height",100,NULL);


  gst_bin_add(GST_BIN(bin),GST_ELEMENT(src));
  gst_bin_add(GST_BIN(bin),GST_ELEMENT(wave));

  gst_pad_connect(gst_element_get_pad(src,"src"),
                  gst_element_get_pad(mp3,"sink"));
  gst_pad_connect(gst_element_get_pad(mp3,"src"),
                  gst_element_get_pad(wave,"sink"));

  appwindow = gnome_app_new("mp3wave","MP3Wave");
  drawingarea = gtk_drawing_area_new();
  gnome_app_set_contents(GNOME_APP(appwindow),gst_util_get_widget_arg(GTK_OBJECT(wave),"widget"));
  gtk_widget_show_all(appwindow);

  gst_element_set_state(GST_ELEMENT(bin),GST_STATE_RUNNING);
  gst_element_set_state(GST_ELEMENT(bin),GST_STATE_PLAYING);

  g_idle_add(idle_func,src);

  gtk_main();
}

gboolean idle_func(gpointer data) {
  gst_src_push(GST_SRC(data));
  return TRUE;
}
