#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <gnome.h>
#include <gst/gst.h>

extern gboolean _gst_plugin_spew;

gboolean idle_func(gpointer data);

GtkWidget *drawingarea;

int main(int argc,char *argv[]) {
  int fd;
  GstElement *bin;
  GstElementFactory *srcfactory;
  GstElement *src;
  GstElement *tee;
  GstElementFactory *wavefactory;
  GstElement *wave;
  GstElementFactory *sinkfactory;
  GstElement *sink;

  GtkWidget *appwindow;

  _gst_plugin_spew = TRUE;

  gst_init(&argc,&argv);
  gst_plugin_load("libsmoothwave.so");
  gnome_init("Wave","0.0.1",argc,argv);

  bin = gst_bin_new("bin");

  srcfactory = gst_elementfactory_find("audiosrc");
  wavefactory = gst_elementfactory_find("smoothwave");
  sinkfactory = gst_elementfactory_find("fdsink");

  src = gst_elementfactory_create(srcfactory,"src");
  gtk_object_set(GTK_OBJECT(src),"bytes_per_read",(gulong)2048,NULL);
  if (argc == 3) {
    g_print("recording from %s\n",argv[2]);
    gtk_object_set(GTK_OBJECT(src),"location",argv[2],NULL);
  }

  tee = gst_tee_new("tee");

  wave = gst_elementfactory_create(wavefactory,"wave");
  gtk_object_set(GTK_OBJECT(wave),"width",512,"height",256,NULL);

  fd = open(argv[1],O_CREAT|O_RDWR);
  sink = gst_elementfactory_create(sinkfactory,"sink");
  gtk_object_set(GTK_OBJECT(sink),"fd",fd,NULL);

  gst_bin_add(GST_BIN(bin),GST_ELEMENT(src));
  gst_bin_add(GST_BIN(bin),GST_ELEMENT(tee));
  gst_bin_add(GST_BIN(bin),GST_ELEMENT(wave));
  gst_bin_add(GST_BIN(bin),GST_ELEMENT(sink));

  gst_pad_connect(gst_element_get_pad(src,"src"),
                  gst_element_get_pad(tee,"sink"));
  gst_pad_connect(gst_element_get_pad(tee,gst_tee_new_pad(GST_TEE(tee))),
                  gst_element_get_pad(sink,"sink"));
  gst_pad_connect(gst_element_get_pad(tee,gst_tee_new_pad(GST_TEE(tee))),
                  gst_element_get_pad(wave,"sink"));

  appwindow = gnome_app_new("wave","Wave");
  drawingarea = gtk_drawing_area_new();
  gnome_app_set_contents(GNOME_APP(appwindow),gst_util_get_widget_arg(GTK_OBJECT(wave),"widget"));
  gtk_widget_show_all(appwindow);

  gst_element_set_state(GST_ELEMENT(bin),GST_STATE_RUNNING);
  gst_element_set_state(GST_ELEMENT(bin),GST_STATE_PLAYING);

  g_idle_add(idle_func,src);

  gtk_main();
}

gboolean idle_func(gpointer data) {
  gst_src_push(GST_SRC(data));
  return TRUE;
}
